VERSION 5.00
Begin VB.Form Form7 
   Caption         =   "playing with files and directories"
   ClientHeight    =   4380
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7800
   LinkTopic       =   "Form7"
   ScaleHeight     =   4380
   ScaleWidth      =   7800
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstFileLines 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1260
      ItemData        =   "Form7.frx":0000
      Left            =   120
      List            =   "Form7.frx":0002
      TabIndex        =   7
      Top             =   2400
      Width           =   3615
   End
   Begin VB.CommandButton cmdRead 
      Caption         =   "read the lines in the non-empty file"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3960
      TabIndex        =   6
      Top             =   2400
      Width           =   3615
   End
   Begin VB.CommandButton cmdAddToFile 
      Caption         =   "add to the existing file"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3960
      TabIndex        =   5
      Top             =   1200
      Width           =   3615
   End
   Begin VB.CommandButton cmdNonEmpty 
      Caption         =   "add a non-empty file to the directory"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3960
      TabIndex        =   4
      Top             =   1800
      Width           =   3615
   End
   Begin VB.CommandButton cmdMakeEmptyFile 
      Caption         =   "add an empty file to the directory"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3960
      TabIndex        =   3
      Top             =   600
      Width           =   3615
   End
   Begin VB.CommandButton cmdKillAll 
      Caption         =   "kill files AND directory"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1800
      Width           =   3615
   End
   Begin VB.CommandButton cmdKillDir 
      Caption         =   "kill existing directory (if empty)"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1200
      Width           =   3615
   End
   Begin VB.CommandButton cmdMakeDir 
      Caption         =   "make a directory for this play session"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   3615
   End
   Begin VB.Label labHead 
      Alignment       =   2  'Center
      Caption         =   "file I/O using old-style ""open"", etc. (not the FSO)"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   7455
   End
End
Attribute VB_Name = "Form7"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public tempdir As String

Private Sub cmdAddToFile_Click()
    Dim filenum As Integer
    
    On Error Resume Next
    '
    ' get the next free file number
    '
    filenum = FreeFile
    '
    ' open a file with that number
    '
    Open tempdir & "\empty.txt" For Append As #filenum
    If Err.Number <> 0 Then
        MsgBox "error adding to file"
    End If
    '
    ' add a couple of lines
    '
    Print #filenum, "first added line"
    Print #filenum, "second added line"
    '
    ' close the file
    '
    Close filenum
End Sub

'
' cmdMakeDir_Click --- make a directory for this exercise
'
Private Sub cmdMakeDir_Click()
    Dim str As String
    
    str = Dir(tempdir, vbDirectory)
    If str <> "" Then
        MsgBox "vbtemp directory already exists, so no need to create it"
    Else
        MkDir tempdir
    End If
End Sub
'
' cmdKillDir_Click --- kill the directory if possible
'
Private Sub cmdKillDir_Click()
    Dim str As String
    
    On Error Resume Next
    '
    ' see if the directory is empty
    '
    str = Dir(tempdir & "\*.*")
    '
    ' if it's empty, kill it
    '
    If str = "" Then
        remove_directory
    Else
        MsgBox "directory is not empty, so I can't kill it"
    End If
End Sub
'
' cmdKillAll_Click --- kill any files in the directory, and then kill the
'                      directory itself
'
Private Sub cmdKillAll_Click()
    On Error Resume Next
    
    Kill tempdir & "\*.*"
    If Err.Number = 53 Then
        MsgBox "there were no files, so I didn't kill any; now I'll kill the directory"
        Err.Number = 0
    Else
        lstFileLines.Clear
    End If
    remove_directory
End Sub
'
' cmdMakeEmptyFile_Click --- add an empty file to the directory; note that
'                            if the file already exists, this all becomes
'                            a "no-op"
'
Private Sub cmdMakeEmptyFile_Click()
    Dim filenum As Integer
    
    On Error Resume Next
    '
    ' get the next free file number
    '
    filenum = FreeFile
    '
    ' open a file with that number
    '
    Open tempdir & "\empty.txt" For Output As #filenum
    If Err.Number = 76 Then
        MsgBox "directory doesn't exist, so could not add empty file"
    ElseIf Err.Number <> 0 Then
        MsgBox "error # " & Err.Number & " while attempting to add empty file"
    Else
        '
        ' no error while opening, so close the file
        '
        Close filenum
    End If
End Sub
'
' cmdNonEmpty_Click --- add a non-empty file to the directory
'
Private Sub cmdNonEmpty_Click()
    Dim filenum As Integer
    
    On Error Resume Next
    '
    ' get the next free file number
    '
    filenum = FreeFile
    '
    ' open a file with that number (note: if one already exists with
    ' the specified name, it will be overwritten)
    '
    Open tempdir & "\nonempty.txt" For Output As #filenum
    If Err.Number = 76 Then
        MsgBox "directory does not exist, so cannot add a file"
    ElseIf Err.Number <> 0 Then
        MsgBox "error # " & Err.Number & " while attempting to add file"
    Else
        '
        ' file opened OK, so put a couple of lines in it
        '
        Print #filenum, "here's a line"
        Print #filenum, "and here's another"
        '
        ' close the file
        '
        Close filenum
    End If
End Sub
'
' cmdRead_Click --- read the lines in the (presumably) non-empty file
'                   and put them into the list box
'
Private Sub cmdRead_Click()
    Dim buff As String
    
    On Error Resume Next
    Open tempdir & "\nonempty.txt" For Input As #1
    If Err.Number <> 0 Then
        MsgBox "file not found"
        Exit Sub
    End If
    Do Until EOF(1)
        Line Input #1, buff
        lstFileLines.AddItem buff
    Loop
    Close #1

End Sub
'
' Form_Load --- file play form is loading, so center it and init the path
'               for this exercise
'
Private Sub Form_Load()
    '
    ' center this form
    '
    Me.Left = (scrWide - Me.Width) / 2
    Me.Top = (scrHigh - Me.Height) / 2
    '
    ' init the path for this exercise
    '
    tempdir = "c:\vbtemp"
    '
    ' hide the main form while this one is up
    '
    Form1.Visible = False
End Sub
'
' remove_directory --- remove the directory (if it's empty)
'
Public Sub remove_directory()
    On Error Resume Next
    RmDir tempdir
    If Err.Number = 76 Then
        MsgBox "could not remove directory, 'cause it doesn't exist"
    End If
End Sub
'
' Form_Unload --- when you unload this form, bring the main one
'                 back into view
'
Private Sub Form_Unload(Cancel As Integer)
    Form1.Visible = True
End Sub
